/* Copyright (C) 2021 John Törnblom

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 3, or (at your option) any
later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING. If not, see
<http://www.gnu.org/licenses/>.  */

#include <stdarg.h>
#include <stdio.h>
#include <sys/prctl.h>


/**
 * Print a notification to stdout.
 **/
void
sys_notify(const char *fmt, ...) {
  va_list args;
  char str[1024];
    
  va_start(args, fmt);
  vsnprintf(str, sizeof(str), fmt, args);
  va_end(args);

  printf("notify: %s\n", str);
}



void
sys_setprocname(const char* name) {
  if(prctl(PR_SET_NAME, name, 0, 0, 0)) {
    perror("prctl");
  }
}

